<?php


abstract class BaseTblscormcminode extends BaseObject  implements Persistent {


	
	protected static $peer;

	
	protected $accesscount;

	
	protected $accessduration;

	
	protected $accessed;

	
	protected $activityabsduration;

	
	protected $activityattemptcount;

	
	protected $activityexpduration;

	
	protected $activityprogstatus;

	
	protected $attemptabsduration;

	
	protected $attemptcomplamount;

	
	protected $attemptcomplstatus;

	
	protected $attemptexpduration;

	
	protected $attemptprogstatus;

	
	protected $audio_captioning;

	
	protected $audio_level;

	
	protected $availablechildren;

	
	protected $cmi_node_id;

	
	protected $completion;

	
	protected $completion_status;

	
	protected $completion_threshold;

	
	protected $cp_node_id;

	
	protected $created;

	
	protected $credit;

	
	protected $delivery_speed;

	
	protected $c_entry;

	
	protected $c_exit;

	
	protected $c_language;

	
	protected $launch_data;

	
	protected $learner_name;

	
	protected $location;

	
	protected $c_max;

	
	protected $c_min;

	
	protected $c_mode;

	
	protected $modified;

	
	protected $progress_measure;

	
	protected $c_raw;

	
	protected $scaled;

	
	protected $scaled_passing_score;

	
	protected $session_time;

	
	protected $success_status;

	
	protected $suspend_data;

	
	protected $total_time;

	
	protected $user_id;

	
	protected $c_timestamp;

	
	protected $additional_tables;

	
	protected $aTblscormcpnode;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->cp_node_id = 0;
		$this->user_id = 0;
		$this->additional_tables = 0;
	}

	
	public function getAccesscount()
	{
		return $this->accesscount;
	}

	
	public function getAccessduration()
	{
		return $this->accessduration;
	}

	
	public function getAccessed()
	{
		return $this->accessed;
	}

	
	public function getActivityabsduration()
	{
		return $this->activityabsduration;
	}

	
	public function getActivityattemptcount()
	{
		return $this->activityattemptcount;
	}

	
	public function getActivityexpduration()
	{
		return $this->activityexpduration;
	}

	
	public function getActivityprogstatus()
	{
		return $this->activityprogstatus;
	}

	
	public function getAttemptabsduration()
	{
		return $this->attemptabsduration;
	}

	
	public function getAttemptcomplamount()
	{
		return $this->attemptcomplamount;
	}

	
	public function getAttemptcomplstatus()
	{
		return $this->attemptcomplstatus;
	}

	
	public function getAttemptexpduration()
	{
		return $this->attemptexpduration;
	}

	
	public function getAttemptprogstatus()
	{
		return $this->attemptprogstatus;
	}

	
	public function getAudioCaptioning()
	{
		return $this->audio_captioning;
	}

	
	public function getAudioLevel()
	{
		return $this->audio_level;
	}

	
	public function getAvailablechildren()
	{
		return $this->availablechildren;
	}

	
	public function getCmiNodeId()
	{
		return $this->cmi_node_id;
	}

	
	public function getCompletion()
	{
		return $this->completion;
	}

	
	public function getCompletionStatus()
	{
		return $this->completion_status;
	}

	
	public function getCompletionThreshold()
	{
		return $this->completion_threshold;
	}

	
	public function getCpNodeId()
	{
		return $this->cp_node_id;
	}

	
	public function getCreated()
	{
		return $this->created;
	}

	
	public function getCredit()
	{
		return $this->credit;
	}

	
	public function getDeliverySpeed()
	{
		return $this->delivery_speed;
	}

	
	public function getCEntry()
	{
		return $this->c_entry;
	}

	
	public function getCExit()
	{
		return $this->c_exit;
	}

	
	public function getCLanguage()
	{
		return $this->c_language;
	}

	
	public function getLaunchData()
	{
		return $this->launch_data;
	}

	
	public function getLearnerName()
	{
		return $this->learner_name;
	}

	
	public function getLocation()
	{
		return $this->location;
	}

	
	public function getCMax()
	{
		return $this->c_max;
	}

	
	public function getCMin()
	{
		return $this->c_min;
	}

	
	public function getCMode()
	{
		return $this->c_mode;
	}

	
	public function getModified()
	{
		return $this->modified;
	}

	
	public function getProgressMeasure()
	{
		return $this->progress_measure;
	}

	
	public function getCRaw()
	{
		return $this->c_raw;
	}

	
	public function getScaled()
	{
		return $this->scaled;
	}

	
	public function getScaledPassingScore()
	{
		return $this->scaled_passing_score;
	}

	
	public function getSessionTime()
	{
		return $this->session_time;
	}

	
	public function getSuccessStatus()
	{
		return $this->success_status;
	}

	
	public function getSuspendData()
	{
		return $this->suspend_data;
	}

	
	public function getTotalTime()
	{
		return $this->total_time;
	}

	
	public function getUserId()
	{
		return $this->user_id;
	}

	
	public function getCTimestamp($format = 'Y-m-d H:i:s')
	{
		if ($this->c_timestamp === null) {
			return null;
		}


		if ($this->c_timestamp === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->c_timestamp);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->c_timestamp, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getAdditionalTables()
	{
		return $this->additional_tables;
	}

	
	public function setAccesscount($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->accesscount !== $v) {
			$this->accesscount = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ACCESSCOUNT;
		}

		return $this;
	} 
	
	public function setAccessduration($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->accessduration !== $v) {
			$this->accessduration = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ACCESSDURATION;
		}

		return $this;
	} 
	
	public function setAccessed($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->accessed !== $v) {
			$this->accessed = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ACCESSED;
		}

		return $this;
	} 
	
	public function setActivityabsduration($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->activityabsduration !== $v) {
			$this->activityabsduration = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ACTIVITYABSDURATION;
		}

		return $this;
	} 
	
	public function setActivityattemptcount($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->activityattemptcount !== $v) {
			$this->activityattemptcount = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ACTIVITYATTEMPTCOUNT;
		}

		return $this;
	} 
	
	public function setActivityexpduration($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->activityexpduration !== $v) {
			$this->activityexpduration = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ACTIVITYEXPDURATION;
		}

		return $this;
	} 
	
	public function setActivityprogstatus($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->activityprogstatus !== $v) {
			$this->activityprogstatus = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ACTIVITYPROGSTATUS;
		}

		return $this;
	} 
	
	public function setAttemptabsduration($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->attemptabsduration !== $v) {
			$this->attemptabsduration = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ATTEMPTABSDURATION;
		}

		return $this;
	} 
	
	public function setAttemptcomplamount($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->attemptcomplamount !== $v) {
			$this->attemptcomplamount = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ATTEMPTCOMPLAMOUNT;
		}

		return $this;
	} 
	
	public function setAttemptcomplstatus($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->attemptcomplstatus !== $v) {
			$this->attemptcomplstatus = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ATTEMPTCOMPLSTATUS;
		}

		return $this;
	} 
	
	public function setAttemptexpduration($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->attemptexpduration !== $v) {
			$this->attemptexpduration = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ATTEMPTEXPDURATION;
		}

		return $this;
	} 
	
	public function setAttemptprogstatus($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->attemptprogstatus !== $v) {
			$this->attemptprogstatus = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ATTEMPTPROGSTATUS;
		}

		return $this;
	} 
	
	public function setAudioCaptioning($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->audio_captioning !== $v) {
			$this->audio_captioning = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::AUDIO_CAPTIONING;
		}

		return $this;
	} 
	
	public function setAudioLevel($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->audio_level !== $v) {
			$this->audio_level = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::AUDIO_LEVEL;
		}

		return $this;
	} 
	
	public function setAvailablechildren($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->availablechildren !== $v) {
			$this->availablechildren = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::AVAILABLECHILDREN;
		}

		return $this;
	} 
	
	public function setCmiNodeId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->cmi_node_id !== $v) {
			$this->cmi_node_id = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::CMI_NODE_ID;
		}

		return $this;
	} 
	
	public function setCompletion($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->completion !== $v) {
			$this->completion = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::COMPLETION;
		}

		return $this;
	} 
	
	public function setCompletionStatus($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->completion_status !== $v) {
			$this->completion_status = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::COMPLETION_STATUS;
		}

		return $this;
	} 
	
	public function setCompletionThreshold($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->completion_threshold !== $v) {
			$this->completion_threshold = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::COMPLETION_THRESHOLD;
		}

		return $this;
	} 
	
	public function setCpNodeId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->cp_node_id !== $v || $v === 0) {
			$this->cp_node_id = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::CP_NODE_ID;
		}

		if ($this->aTblscormcpnode !== null && $this->aTblscormcpnode->getCpNodeId() !== $v) {
			$this->aTblscormcpnode = null;
		}

		return $this;
	} 
	
	public function setCreated($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->created !== $v) {
			$this->created = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::CREATED;
		}

		return $this;
	} 
	
	public function setCredit($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->credit !== $v) {
			$this->credit = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::CREDIT;
		}

		return $this;
	} 
	
	public function setDeliverySpeed($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->delivery_speed !== $v) {
			$this->delivery_speed = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::DELIVERY_SPEED;
		}

		return $this;
	} 
	
	public function setCEntry($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->c_entry !== $v) {
			$this->c_entry = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::C_ENTRY;
		}

		return $this;
	} 
	
	public function setCExit($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->c_exit !== $v) {
			$this->c_exit = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::C_EXIT;
		}

		return $this;
	} 
	
	public function setCLanguage($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->c_language !== $v) {
			$this->c_language = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::C_LANGUAGE;
		}

		return $this;
	} 
	
	public function setLaunchData($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->launch_data !== $v) {
			$this->launch_data = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::LAUNCH_DATA;
		}

		return $this;
	} 
	
	public function setLearnerName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->learner_name !== $v) {
			$this->learner_name = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::LEARNER_NAME;
		}

		return $this;
	} 
	
	public function setLocation($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->location !== $v) {
			$this->location = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::LOCATION;
		}

		return $this;
	} 
	
	public function setCMax($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->c_max !== $v) {
			$this->c_max = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::C_MAX;
		}

		return $this;
	} 
	
	public function setCMin($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->c_min !== $v) {
			$this->c_min = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::C_MIN;
		}

		return $this;
	} 
	
	public function setCMode($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->c_mode !== $v) {
			$this->c_mode = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::C_MODE;
		}

		return $this;
	} 
	
	public function setModified($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->modified !== $v) {
			$this->modified = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::MODIFIED;
		}

		return $this;
	} 
	
	public function setProgressMeasure($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->progress_measure !== $v) {
			$this->progress_measure = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::PROGRESS_MEASURE;
		}

		return $this;
	} 
	
	public function setCRaw($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->c_raw !== $v) {
			$this->c_raw = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::C_RAW;
		}

		return $this;
	} 
	
	public function setScaled($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->scaled !== $v) {
			$this->scaled = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::SCALED;
		}

		return $this;
	} 
	
	public function setScaledPassingScore($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->scaled_passing_score !== $v) {
			$this->scaled_passing_score = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::SCALED_PASSING_SCORE;
		}

		return $this;
	} 
	
	public function setSessionTime($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->session_time !== $v) {
			$this->session_time = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::SESSION_TIME;
		}

		return $this;
	} 
	
	public function setSuccessStatus($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->success_status !== $v) {
			$this->success_status = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::SUCCESS_STATUS;
		}

		return $this;
	} 
	
	public function setSuspendData($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->suspend_data !== $v) {
			$this->suspend_data = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::SUSPEND_DATA;
		}

		return $this;
	} 
	
	public function setTotalTime($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->total_time !== $v) {
			$this->total_time = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::TOTAL_TIME;
		}

		return $this;
	} 
	
	public function setUserId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->user_id !== $v || $v === 0) {
			$this->user_id = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::USER_ID;
		}

		return $this;
	} 
	
	public function setCTimestamp($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->c_timestamp !== null || $dt !== null ) {
			
			$currNorm = ($this->c_timestamp !== null && $tmpDt = new DateTime($this->c_timestamp)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->c_timestamp = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = TblscormcminodePeer::C_TIMESTAMP;
			}
		} 
		return $this;
	} 
	
	public function setAdditionalTables($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->additional_tables !== $v || $v === 0) {
			$this->additional_tables = $v;
			$this->modifiedColumns[] = TblscormcminodePeer::ADDITIONAL_TABLES;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(TblscormcminodePeer::CP_NODE_ID,TblscormcminodePeer::USER_ID,TblscormcminodePeer::ADDITIONAL_TABLES))) {
				return false;
			}

			if ($this->cp_node_id !== 0) {
				return false;
			}

			if ($this->user_id !== 0) {
				return false;
			}

			if ($this->additional_tables !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->accesscount = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->accessduration = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->accessed = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->activityabsduration = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->activityattemptcount = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->activityexpduration = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->activityprogstatus = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
			$this->attemptabsduration = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->attemptcomplamount = ($row[$startcol + 8] !== null) ? (double) $row[$startcol + 8] : null;
			$this->attemptcomplstatus = ($row[$startcol + 9] !== null) ? (int) $row[$startcol + 9] : null;
			$this->attemptexpduration = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
			$this->attemptprogstatus = ($row[$startcol + 11] !== null) ? (int) $row[$startcol + 11] : null;
			$this->audio_captioning = ($row[$startcol + 12] !== null) ? (int) $row[$startcol + 12] : null;
			$this->audio_level = ($row[$startcol + 13] !== null) ? (double) $row[$startcol + 13] : null;
			$this->availablechildren = ($row[$startcol + 14] !== null) ? (string) $row[$startcol + 14] : null;
			$this->cmi_node_id = ($row[$startcol + 15] !== null) ? (int) $row[$startcol + 15] : null;
			$this->completion = ($row[$startcol + 16] !== null) ? (double) $row[$startcol + 16] : null;
			$this->completion_status = ($row[$startcol + 17] !== null) ? (string) $row[$startcol + 17] : null;
			$this->completion_threshold = ($row[$startcol + 18] !== null) ? (string) $row[$startcol + 18] : null;
			$this->cp_node_id = ($row[$startcol + 19] !== null) ? (int) $row[$startcol + 19] : null;
			$this->created = ($row[$startcol + 20] !== null) ? (string) $row[$startcol + 20] : null;
			$this->credit = ($row[$startcol + 21] !== null) ? (string) $row[$startcol + 21] : null;
			$this->delivery_speed = ($row[$startcol + 22] !== null) ? (double) $row[$startcol + 22] : null;
			$this->c_entry = ($row[$startcol + 23] !== null) ? (string) $row[$startcol + 23] : null;
			$this->c_exit = ($row[$startcol + 24] !== null) ? (string) $row[$startcol + 24] : null;
			$this->c_language = ($row[$startcol + 25] !== null) ? (string) $row[$startcol + 25] : null;
			$this->launch_data = ($row[$startcol + 26] !== null) ? (string) $row[$startcol + 26] : null;
			$this->learner_name = ($row[$startcol + 27] !== null) ? (string) $row[$startcol + 27] : null;
			$this->location = ($row[$startcol + 28] !== null) ? (string) $row[$startcol + 28] : null;
			$this->c_max = ($row[$startcol + 29] !== null) ? (double) $row[$startcol + 29] : null;
			$this->c_min = ($row[$startcol + 30] !== null) ? (double) $row[$startcol + 30] : null;
			$this->c_mode = ($row[$startcol + 31] !== null) ? (string) $row[$startcol + 31] : null;
			$this->modified = ($row[$startcol + 32] !== null) ? (string) $row[$startcol + 32] : null;
			$this->progress_measure = ($row[$startcol + 33] !== null) ? (double) $row[$startcol + 33] : null;
			$this->c_raw = ($row[$startcol + 34] !== null) ? (double) $row[$startcol + 34] : null;
			$this->scaled = ($row[$startcol + 35] !== null) ? (double) $row[$startcol + 35] : null;
			$this->scaled_passing_score = ($row[$startcol + 36] !== null) ? (double) $row[$startcol + 36] : null;
			$this->session_time = ($row[$startcol + 37] !== null) ? (string) $row[$startcol + 37] : null;
			$this->success_status = ($row[$startcol + 38] !== null) ? (string) $row[$startcol + 38] : null;
			$this->suspend_data = ($row[$startcol + 39] !== null) ? (string) $row[$startcol + 39] : null;
			$this->total_time = ($row[$startcol + 40] !== null) ? (string) $row[$startcol + 40] : null;
			$this->user_id = ($row[$startcol + 41] !== null) ? (int) $row[$startcol + 41] : null;
			$this->c_timestamp = ($row[$startcol + 42] !== null) ? (string) $row[$startcol + 42] : null;
			$this->additional_tables = ($row[$startcol + 43] !== null) ? (int) $row[$startcol + 43] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 44; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Tblscormcminode object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aTblscormcpnode !== null && $this->cp_node_id !== $this->aTblscormcpnode->getCpNodeId()) {
			$this->aTblscormcpnode = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TblscormcminodePeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = TblscormcminodePeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aTblscormcpnode = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TblscormcminodePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			TblscormcminodePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TblscormcminodePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			TblscormcminodePeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aTblscormcpnode !== null) {
				if ($this->aTblscormcpnode->isModified() || $this->aTblscormcpnode->isNew()) {
					$affectedRows += $this->aTblscormcpnode->save($con);
				}
				$this->setTblscormcpnode($this->aTblscormcpnode);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = TblscormcminodePeer::CMI_NODE_ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TblscormcminodePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setCmiNodeId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += TblscormcminodePeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aTblscormcpnode !== null) {
				if (!$this->aTblscormcpnode->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTblscormcpnode->getValidationFailures());
				}
			}


			if (($retval = TblscormcminodePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TblscormcminodePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getAccesscount();
				break;
			case 1:
				return $this->getAccessduration();
				break;
			case 2:
				return $this->getAccessed();
				break;
			case 3:
				return $this->getActivityabsduration();
				break;
			case 4:
				return $this->getActivityattemptcount();
				break;
			case 5:
				return $this->getActivityexpduration();
				break;
			case 6:
				return $this->getActivityprogstatus();
				break;
			case 7:
				return $this->getAttemptabsduration();
				break;
			case 8:
				return $this->getAttemptcomplamount();
				break;
			case 9:
				return $this->getAttemptcomplstatus();
				break;
			case 10:
				return $this->getAttemptexpduration();
				break;
			case 11:
				return $this->getAttemptprogstatus();
				break;
			case 12:
				return $this->getAudioCaptioning();
				break;
			case 13:
				return $this->getAudioLevel();
				break;
			case 14:
				return $this->getAvailablechildren();
				break;
			case 15:
				return $this->getCmiNodeId();
				break;
			case 16:
				return $this->getCompletion();
				break;
			case 17:
				return $this->getCompletionStatus();
				break;
			case 18:
				return $this->getCompletionThreshold();
				break;
			case 19:
				return $this->getCpNodeId();
				break;
			case 20:
				return $this->getCreated();
				break;
			case 21:
				return $this->getCredit();
				break;
			case 22:
				return $this->getDeliverySpeed();
				break;
			case 23:
				return $this->getCEntry();
				break;
			case 24:
				return $this->getCExit();
				break;
			case 25:
				return $this->getCLanguage();
				break;
			case 26:
				return $this->getLaunchData();
				break;
			case 27:
				return $this->getLearnerName();
				break;
			case 28:
				return $this->getLocation();
				break;
			case 29:
				return $this->getCMax();
				break;
			case 30:
				return $this->getCMin();
				break;
			case 31:
				return $this->getCMode();
				break;
			case 32:
				return $this->getModified();
				break;
			case 33:
				return $this->getProgressMeasure();
				break;
			case 34:
				return $this->getCRaw();
				break;
			case 35:
				return $this->getScaled();
				break;
			case 36:
				return $this->getScaledPassingScore();
				break;
			case 37:
				return $this->getSessionTime();
				break;
			case 38:
				return $this->getSuccessStatus();
				break;
			case 39:
				return $this->getSuspendData();
				break;
			case 40:
				return $this->getTotalTime();
				break;
			case 41:
				return $this->getUserId();
				break;
			case 42:
				return $this->getCTimestamp();
				break;
			case 43:
				return $this->getAdditionalTables();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = TblscormcminodePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getAccesscount(),
			$keys[1] => $this->getAccessduration(),
			$keys[2] => $this->getAccessed(),
			$keys[3] => $this->getActivityabsduration(),
			$keys[4] => $this->getActivityattemptcount(),
			$keys[5] => $this->getActivityexpduration(),
			$keys[6] => $this->getActivityprogstatus(),
			$keys[7] => $this->getAttemptabsduration(),
			$keys[8] => $this->getAttemptcomplamount(),
			$keys[9] => $this->getAttemptcomplstatus(),
			$keys[10] => $this->getAttemptexpduration(),
			$keys[11] => $this->getAttemptprogstatus(),
			$keys[12] => $this->getAudioCaptioning(),
			$keys[13] => $this->getAudioLevel(),
			$keys[14] => $this->getAvailablechildren(),
			$keys[15] => $this->getCmiNodeId(),
			$keys[16] => $this->getCompletion(),
			$keys[17] => $this->getCompletionStatus(),
			$keys[18] => $this->getCompletionThreshold(),
			$keys[19] => $this->getCpNodeId(),
			$keys[20] => $this->getCreated(),
			$keys[21] => $this->getCredit(),
			$keys[22] => $this->getDeliverySpeed(),
			$keys[23] => $this->getCEntry(),
			$keys[24] => $this->getCExit(),
			$keys[25] => $this->getCLanguage(),
			$keys[26] => $this->getLaunchData(),
			$keys[27] => $this->getLearnerName(),
			$keys[28] => $this->getLocation(),
			$keys[29] => $this->getCMax(),
			$keys[30] => $this->getCMin(),
			$keys[31] => $this->getCMode(),
			$keys[32] => $this->getModified(),
			$keys[33] => $this->getProgressMeasure(),
			$keys[34] => $this->getCRaw(),
			$keys[35] => $this->getScaled(),
			$keys[36] => $this->getScaledPassingScore(),
			$keys[37] => $this->getSessionTime(),
			$keys[38] => $this->getSuccessStatus(),
			$keys[39] => $this->getSuspendData(),
			$keys[40] => $this->getTotalTime(),
			$keys[41] => $this->getUserId(),
			$keys[42] => $this->getCTimestamp(),
			$keys[43] => $this->getAdditionalTables(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TblscormcminodePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setAccesscount($value);
				break;
			case 1:
				$this->setAccessduration($value);
				break;
			case 2:
				$this->setAccessed($value);
				break;
			case 3:
				$this->setActivityabsduration($value);
				break;
			case 4:
				$this->setActivityattemptcount($value);
				break;
			case 5:
				$this->setActivityexpduration($value);
				break;
			case 6:
				$this->setActivityprogstatus($value);
				break;
			case 7:
				$this->setAttemptabsduration($value);
				break;
			case 8:
				$this->setAttemptcomplamount($value);
				break;
			case 9:
				$this->setAttemptcomplstatus($value);
				break;
			case 10:
				$this->setAttemptexpduration($value);
				break;
			case 11:
				$this->setAttemptprogstatus($value);
				break;
			case 12:
				$this->setAudioCaptioning($value);
				break;
			case 13:
				$this->setAudioLevel($value);
				break;
			case 14:
				$this->setAvailablechildren($value);
				break;
			case 15:
				$this->setCmiNodeId($value);
				break;
			case 16:
				$this->setCompletion($value);
				break;
			case 17:
				$this->setCompletionStatus($value);
				break;
			case 18:
				$this->setCompletionThreshold($value);
				break;
			case 19:
				$this->setCpNodeId($value);
				break;
			case 20:
				$this->setCreated($value);
				break;
			case 21:
				$this->setCredit($value);
				break;
			case 22:
				$this->setDeliverySpeed($value);
				break;
			case 23:
				$this->setCEntry($value);
				break;
			case 24:
				$this->setCExit($value);
				break;
			case 25:
				$this->setCLanguage($value);
				break;
			case 26:
				$this->setLaunchData($value);
				break;
			case 27:
				$this->setLearnerName($value);
				break;
			case 28:
				$this->setLocation($value);
				break;
			case 29:
				$this->setCMax($value);
				break;
			case 30:
				$this->setCMin($value);
				break;
			case 31:
				$this->setCMode($value);
				break;
			case 32:
				$this->setModified($value);
				break;
			case 33:
				$this->setProgressMeasure($value);
				break;
			case 34:
				$this->setCRaw($value);
				break;
			case 35:
				$this->setScaled($value);
				break;
			case 36:
				$this->setScaledPassingScore($value);
				break;
			case 37:
				$this->setSessionTime($value);
				break;
			case 38:
				$this->setSuccessStatus($value);
				break;
			case 39:
				$this->setSuspendData($value);
				break;
			case 40:
				$this->setTotalTime($value);
				break;
			case 41:
				$this->setUserId($value);
				break;
			case 42:
				$this->setCTimestamp($value);
				break;
			case 43:
				$this->setAdditionalTables($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = TblscormcminodePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setAccesscount($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setAccessduration($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setAccessed($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setActivityabsduration($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setActivityattemptcount($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setActivityexpduration($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setActivityprogstatus($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setAttemptabsduration($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setAttemptcomplamount($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setAttemptcomplstatus($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setAttemptexpduration($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setAttemptprogstatus($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setAudioCaptioning($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setAudioLevel($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setAvailablechildren($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setCmiNodeId($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setCompletion($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setCompletionStatus($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setCompletionThreshold($arr[$keys[18]]);
		if (array_key_exists($keys[19], $arr)) $this->setCpNodeId($arr[$keys[19]]);
		if (array_key_exists($keys[20], $arr)) $this->setCreated($arr[$keys[20]]);
		if (array_key_exists($keys[21], $arr)) $this->setCredit($arr[$keys[21]]);
		if (array_key_exists($keys[22], $arr)) $this->setDeliverySpeed($arr[$keys[22]]);
		if (array_key_exists($keys[23], $arr)) $this->setCEntry($arr[$keys[23]]);
		if (array_key_exists($keys[24], $arr)) $this->setCExit($arr[$keys[24]]);
		if (array_key_exists($keys[25], $arr)) $this->setCLanguage($arr[$keys[25]]);
		if (array_key_exists($keys[26], $arr)) $this->setLaunchData($arr[$keys[26]]);
		if (array_key_exists($keys[27], $arr)) $this->setLearnerName($arr[$keys[27]]);
		if (array_key_exists($keys[28], $arr)) $this->setLocation($arr[$keys[28]]);
		if (array_key_exists($keys[29], $arr)) $this->setCMax($arr[$keys[29]]);
		if (array_key_exists($keys[30], $arr)) $this->setCMin($arr[$keys[30]]);
		if (array_key_exists($keys[31], $arr)) $this->setCMode($arr[$keys[31]]);
		if (array_key_exists($keys[32], $arr)) $this->setModified($arr[$keys[32]]);
		if (array_key_exists($keys[33], $arr)) $this->setProgressMeasure($arr[$keys[33]]);
		if (array_key_exists($keys[34], $arr)) $this->setCRaw($arr[$keys[34]]);
		if (array_key_exists($keys[35], $arr)) $this->setScaled($arr[$keys[35]]);
		if (array_key_exists($keys[36], $arr)) $this->setScaledPassingScore($arr[$keys[36]]);
		if (array_key_exists($keys[37], $arr)) $this->setSessionTime($arr[$keys[37]]);
		if (array_key_exists($keys[38], $arr)) $this->setSuccessStatus($arr[$keys[38]]);
		if (array_key_exists($keys[39], $arr)) $this->setSuspendData($arr[$keys[39]]);
		if (array_key_exists($keys[40], $arr)) $this->setTotalTime($arr[$keys[40]]);
		if (array_key_exists($keys[41], $arr)) $this->setUserId($arr[$keys[41]]);
		if (array_key_exists($keys[42], $arr)) $this->setCTimestamp($arr[$keys[42]]);
		if (array_key_exists($keys[43], $arr)) $this->setAdditionalTables($arr[$keys[43]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(TblscormcminodePeer::DATABASE_NAME);

		if ($this->isColumnModified(TblscormcminodePeer::ACCESSCOUNT)) $criteria->add(TblscormcminodePeer::ACCESSCOUNT, $this->accesscount);
		if ($this->isColumnModified(TblscormcminodePeer::ACCESSDURATION)) $criteria->add(TblscormcminodePeer::ACCESSDURATION, $this->accessduration);
		if ($this->isColumnModified(TblscormcminodePeer::ACCESSED)) $criteria->add(TblscormcminodePeer::ACCESSED, $this->accessed);
		if ($this->isColumnModified(TblscormcminodePeer::ACTIVITYABSDURATION)) $criteria->add(TblscormcminodePeer::ACTIVITYABSDURATION, $this->activityabsduration);
		if ($this->isColumnModified(TblscormcminodePeer::ACTIVITYATTEMPTCOUNT)) $criteria->add(TblscormcminodePeer::ACTIVITYATTEMPTCOUNT, $this->activityattemptcount);
		if ($this->isColumnModified(TblscormcminodePeer::ACTIVITYEXPDURATION)) $criteria->add(TblscormcminodePeer::ACTIVITYEXPDURATION, $this->activityexpduration);
		if ($this->isColumnModified(TblscormcminodePeer::ACTIVITYPROGSTATUS)) $criteria->add(TblscormcminodePeer::ACTIVITYPROGSTATUS, $this->activityprogstatus);
		if ($this->isColumnModified(TblscormcminodePeer::ATTEMPTABSDURATION)) $criteria->add(TblscormcminodePeer::ATTEMPTABSDURATION, $this->attemptabsduration);
		if ($this->isColumnModified(TblscormcminodePeer::ATTEMPTCOMPLAMOUNT)) $criteria->add(TblscormcminodePeer::ATTEMPTCOMPLAMOUNT, $this->attemptcomplamount);
		if ($this->isColumnModified(TblscormcminodePeer::ATTEMPTCOMPLSTATUS)) $criteria->add(TblscormcminodePeer::ATTEMPTCOMPLSTATUS, $this->attemptcomplstatus);
		if ($this->isColumnModified(TblscormcminodePeer::ATTEMPTEXPDURATION)) $criteria->add(TblscormcminodePeer::ATTEMPTEXPDURATION, $this->attemptexpduration);
		if ($this->isColumnModified(TblscormcminodePeer::ATTEMPTPROGSTATUS)) $criteria->add(TblscormcminodePeer::ATTEMPTPROGSTATUS, $this->attemptprogstatus);
		if ($this->isColumnModified(TblscormcminodePeer::AUDIO_CAPTIONING)) $criteria->add(TblscormcminodePeer::AUDIO_CAPTIONING, $this->audio_captioning);
		if ($this->isColumnModified(TblscormcminodePeer::AUDIO_LEVEL)) $criteria->add(TblscormcminodePeer::AUDIO_LEVEL, $this->audio_level);
		if ($this->isColumnModified(TblscormcminodePeer::AVAILABLECHILDREN)) $criteria->add(TblscormcminodePeer::AVAILABLECHILDREN, $this->availablechildren);
		if ($this->isColumnModified(TblscormcminodePeer::CMI_NODE_ID)) $criteria->add(TblscormcminodePeer::CMI_NODE_ID, $this->cmi_node_id);
		if ($this->isColumnModified(TblscormcminodePeer::COMPLETION)) $criteria->add(TblscormcminodePeer::COMPLETION, $this->completion);
		if ($this->isColumnModified(TblscormcminodePeer::COMPLETION_STATUS)) $criteria->add(TblscormcminodePeer::COMPLETION_STATUS, $this->completion_status);
		if ($this->isColumnModified(TblscormcminodePeer::COMPLETION_THRESHOLD)) $criteria->add(TblscormcminodePeer::COMPLETION_THRESHOLD, $this->completion_threshold);
		if ($this->isColumnModified(TblscormcminodePeer::CP_NODE_ID)) $criteria->add(TblscormcminodePeer::CP_NODE_ID, $this->cp_node_id);
		if ($this->isColumnModified(TblscormcminodePeer::CREATED)) $criteria->add(TblscormcminodePeer::CREATED, $this->created);
		if ($this->isColumnModified(TblscormcminodePeer::CREDIT)) $criteria->add(TblscormcminodePeer::CREDIT, $this->credit);
		if ($this->isColumnModified(TblscormcminodePeer::DELIVERY_SPEED)) $criteria->add(TblscormcminodePeer::DELIVERY_SPEED, $this->delivery_speed);
		if ($this->isColumnModified(TblscormcminodePeer::C_ENTRY)) $criteria->add(TblscormcminodePeer::C_ENTRY, $this->c_entry);
		if ($this->isColumnModified(TblscormcminodePeer::C_EXIT)) $criteria->add(TblscormcminodePeer::C_EXIT, $this->c_exit);
		if ($this->isColumnModified(TblscormcminodePeer::C_LANGUAGE)) $criteria->add(TblscormcminodePeer::C_LANGUAGE, $this->c_language);
		if ($this->isColumnModified(TblscormcminodePeer::LAUNCH_DATA)) $criteria->add(TblscormcminodePeer::LAUNCH_DATA, $this->launch_data);
		if ($this->isColumnModified(TblscormcminodePeer::LEARNER_NAME)) $criteria->add(TblscormcminodePeer::LEARNER_NAME, $this->learner_name);
		if ($this->isColumnModified(TblscormcminodePeer::LOCATION)) $criteria->add(TblscormcminodePeer::LOCATION, $this->location);
		if ($this->isColumnModified(TblscormcminodePeer::C_MAX)) $criteria->add(TblscormcminodePeer::C_MAX, $this->c_max);
		if ($this->isColumnModified(TblscormcminodePeer::C_MIN)) $criteria->add(TblscormcminodePeer::C_MIN, $this->c_min);
		if ($this->isColumnModified(TblscormcminodePeer::C_MODE)) $criteria->add(TblscormcminodePeer::C_MODE, $this->c_mode);
		if ($this->isColumnModified(TblscormcminodePeer::MODIFIED)) $criteria->add(TblscormcminodePeer::MODIFIED, $this->modified);
		if ($this->isColumnModified(TblscormcminodePeer::PROGRESS_MEASURE)) $criteria->add(TblscormcminodePeer::PROGRESS_MEASURE, $this->progress_measure);
		if ($this->isColumnModified(TblscormcminodePeer::C_RAW)) $criteria->add(TblscormcminodePeer::C_RAW, $this->c_raw);
		if ($this->isColumnModified(TblscormcminodePeer::SCALED)) $criteria->add(TblscormcminodePeer::SCALED, $this->scaled);
		if ($this->isColumnModified(TblscormcminodePeer::SCALED_PASSING_SCORE)) $criteria->add(TblscormcminodePeer::SCALED_PASSING_SCORE, $this->scaled_passing_score);
		if ($this->isColumnModified(TblscormcminodePeer::SESSION_TIME)) $criteria->add(TblscormcminodePeer::SESSION_TIME, $this->session_time);
		if ($this->isColumnModified(TblscormcminodePeer::SUCCESS_STATUS)) $criteria->add(TblscormcminodePeer::SUCCESS_STATUS, $this->success_status);
		if ($this->isColumnModified(TblscormcminodePeer::SUSPEND_DATA)) $criteria->add(TblscormcminodePeer::SUSPEND_DATA, $this->suspend_data);
		if ($this->isColumnModified(TblscormcminodePeer::TOTAL_TIME)) $criteria->add(TblscormcminodePeer::TOTAL_TIME, $this->total_time);
		if ($this->isColumnModified(TblscormcminodePeer::USER_ID)) $criteria->add(TblscormcminodePeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(TblscormcminodePeer::C_TIMESTAMP)) $criteria->add(TblscormcminodePeer::C_TIMESTAMP, $this->c_timestamp);
		if ($this->isColumnModified(TblscormcminodePeer::ADDITIONAL_TABLES)) $criteria->add(TblscormcminodePeer::ADDITIONAL_TABLES, $this->additional_tables);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(TblscormcminodePeer::DATABASE_NAME);

		$criteria->add(TblscormcminodePeer::CMI_NODE_ID, $this->cmi_node_id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getCmiNodeId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setCmiNodeId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setAccesscount($this->accesscount);

		$copyObj->setAccessduration($this->accessduration);

		$copyObj->setAccessed($this->accessed);

		$copyObj->setActivityabsduration($this->activityabsduration);

		$copyObj->setActivityattemptcount($this->activityattemptcount);

		$copyObj->setActivityexpduration($this->activityexpduration);

		$copyObj->setActivityprogstatus($this->activityprogstatus);

		$copyObj->setAttemptabsduration($this->attemptabsduration);

		$copyObj->setAttemptcomplamount($this->attemptcomplamount);

		$copyObj->setAttemptcomplstatus($this->attemptcomplstatus);

		$copyObj->setAttemptexpduration($this->attemptexpduration);

		$copyObj->setAttemptprogstatus($this->attemptprogstatus);

		$copyObj->setAudioCaptioning($this->audio_captioning);

		$copyObj->setAudioLevel($this->audio_level);

		$copyObj->setAvailablechildren($this->availablechildren);

		$copyObj->setCompletion($this->completion);

		$copyObj->setCompletionStatus($this->completion_status);

		$copyObj->setCompletionThreshold($this->completion_threshold);

		$copyObj->setCpNodeId($this->cp_node_id);

		$copyObj->setCreated($this->created);

		$copyObj->setCredit($this->credit);

		$copyObj->setDeliverySpeed($this->delivery_speed);

		$copyObj->setCEntry($this->c_entry);

		$copyObj->setCExit($this->c_exit);

		$copyObj->setCLanguage($this->c_language);

		$copyObj->setLaunchData($this->launch_data);

		$copyObj->setLearnerName($this->learner_name);

		$copyObj->setLocation($this->location);

		$copyObj->setCMax($this->c_max);

		$copyObj->setCMin($this->c_min);

		$copyObj->setCMode($this->c_mode);

		$copyObj->setModified($this->modified);

		$copyObj->setProgressMeasure($this->progress_measure);

		$copyObj->setCRaw($this->c_raw);

		$copyObj->setScaled($this->scaled);

		$copyObj->setScaledPassingScore($this->scaled_passing_score);

		$copyObj->setSessionTime($this->session_time);

		$copyObj->setSuccessStatus($this->success_status);

		$copyObj->setSuspendData($this->suspend_data);

		$copyObj->setTotalTime($this->total_time);

		$copyObj->setUserId($this->user_id);

		$copyObj->setCTimestamp($this->c_timestamp);

		$copyObj->setAdditionalTables($this->additional_tables);


		$copyObj->setNew(true);

		$copyObj->setCmiNodeId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TblscormcminodePeer();
		}
		return self::$peer;
	}

	
	public function setTblscormcpnode(Tblscormcpnode $v = null)
	{
		if ($v === null) {
			$this->setCpNodeId(0);
		} else {
			$this->setCpNodeId($v->getCpNodeId());
		}

		$this->aTblscormcpnode = $v;

						if ($v !== null) {
			$v->addTblscormcminode($this);
		}

		return $this;
	}


	
	public function getTblscormcpnode(PropelPDO $con = null)
	{
		if ($this->aTblscormcpnode === null && ($this->cp_node_id !== null)) {
			$this->aTblscormcpnode = TblscormcpnodePeer::retrieveByPK($this->cp_node_id, $con);
			
		}
		return $this->aTblscormcpnode;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aTblscormcpnode = null;
	}

} 